alter table reference_data add if not exists real_property_id INTEGER;
update reference_data  set real_property_id=property_id where property_id not in (select distinct value from reference_data where status='replacement');
update reference_data  join reference_data as ref2 on reference_data.entity_id=ref2.entity_id and reference_data.property_id=ref2.value set reference_data.real_property_id=ref2.property_id;

drop index if exists prop on reference_data;
create index prop on reference_data (real_property_id, value);

drop temporary table if exists tmprealids;
drop temporary table if exists tmpresult;
create temporary table tmprealids select distinct child as real_property_id from isa_cache where parent = 112;
insert into tmprealids select 112;
select count(*) from tmprealids;
create temporary table tmpresult (id INTEGER);
set @start = CURRENT_TIMESTAMP(4);
DELIMITER //
set @length = (SELECT COUNT(*) FROM tmprealids)-1;
FOR i IN 0..@length
DO
    insert into tmpresult
    select distinct entity_id from reference_data where real_property_id=(
      select real_property_id from tmprealids limit i,1) and status!="REPLACEMENT" and value!=518;
END FOR;
//

DELIMITER ;
select TIMESTAMPDIFF( MICROSECOND, @start,CURRENT_TIMESTAMP(4))/1000.0 as "spent(ms)";
select count(distinct id) from tmpresult order by id;
--select * from tmpresult;
